%
% Not so mathy things.
%

\newcommand{\etal}{et\,al.\xspace}
\newcommand{\ie}{i.\,e.\xspace}
\newcommand{\eg}{e.\,g.\xspace}
\newcommand{\cf}{cf.\xspace}

%
% Math operators
%

\DeclareMathOperator*\argmin{arg\,min}
\DeclareMathOperator*\argmax{arg\,max}

%
% Symbols with short notation
%

\newcommand\SN{\mathbb{N}}
\newcommand\SR{\mathbb{R}}
\newcommand\SX{\mathcal{X}}
\newcommand\SV{\mathcal{V}}
\newcommand\SE{\mathcal{E}}
\newcommand\SG{\mathcal{G}}
\newcommand\SOne{\mathds{1}}

\newcommand\Sdet{{\mathsf{det}}}
\newcommand\Strans{{\mathsf{trans}}}
\newcommand\Smove{{\mathsf{move}}}
\newcommand\Sdiv{{\mathsf{div}}}
\newcommand\Sconf{{\mathsf{conf}}}
\newcommand\SIn{{\mathsf{in}}}
\newcommand\SOut{{\mathsf{out}}}
\newcommand\Sin{{\mathsf{in}}}
\newcommand\Sout{{\mathsf{out}}}

% Only for supplement
\newcommand\Sapp{{\mathsf{app}}}
\newcommand\Sdis{{\mathsf{dis}}}

\newcommand\SSP[2]{\langle #1, #2 \rangle} % scalar product

%
% More specific symbols.
%

\newcommand\SVar{x}
\newcommand\SCost{\theta}
\newcommand\SRepa{\lambda}
\newcommand\SCostRepa{\SCost^\SRepa}
\newcommand\SMinMar{\Theta}

\newcommand\SEdgeTrans[2]{{#1\!\rightarrow\! #2}}
\newcommand\SHatEdgeTrans[3]{{#1\!\stackrel{#3}{\rightarrow}\! #2}}
\newcommand\SEdgeDiv[3]{{#1\!\rightrightarrows\! #2/#3}}
\newcommand\SHatEdgeDiv[4]{{#1\!\stackrel{\text{\raisebox{-2pt}[0pt][0pt]{$#4$}}}{\rightrightarrows}\! #2/#3}}
\newcommand\SEdgeConf[2]{{#1 \lightning #2}}

\newcommand\SMsg{\Delta}
\newcommand\SMsgLeft[1]{\SMsg^\leftarrow_{#1}}
\newcommand\SMsgRight[1]{\SMsg^\rightarrow_{#1}}
\newcommand\SMsgFromConf[1]{\SMsg^\uparrow_{#1}}
\newcommand\SMsgFromFact[1]{\SMsg^\uparrow_{#1}}

\begingroup
\newcommand{\CreateFactorMacro}[2]{
    \def\name{#1}
    \def\symbol{#2}

    \expandafter\xdef\csname S\name Det\endcsname{\symbol_{\noexpand\Sdet}}
    \expandafter\xdef\csname S\name In\endcsname{\symbol_{\noexpand\Sin}}
    \expandafter\xdef\csname S\name Out\endcsname{\symbol_{\noexpand\Sout}}
    \expandafter\xdef\csname S\name Conf\endcsname{\symbol_{\noexpand\Sconf}}
    \expandafter\xdef\csname S\name Factor\endcsname ##1{\symbol_{##1}}
    \expandafter\xdef\csname S\name FactorDet\endcsname ##1{\symbol_{##1,\noexpand\Sdet}}
    \expandafter\xdef\csname S\name FactorIn\endcsname ##1{\symbol_{##1,\noexpand\Sin}}
    \expandafter\xdef\csname S\name FactorOut\endcsname ##1{\symbol_{##1,\noexpand\Sout}}
    \expandafter\xdef\csname S\name FactorConf\endcsname ##1{\symbol_{##1}}
}
\CreateFactorMacro{Var}{\SVar}
\CreateFactorMacro{Cost}{\SCost}
\CreateFactorMacro{CostRepa}{\SCostRepa}
\CreateFactorMacro{MinMar}{\SMinMar}
\endgroup

